﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Editors;
using System.ComponentModel;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

            List<CustomerType> customerTypes = new List<CustomerType>();
            customerTypes.Add(new CustomerType() { ID = 1, Type = CustomerType.CustomerTypes.Standard });
            customerTypes.Add(new CustomerType() { ID = 2, Type = CustomerType.CustomerTypes.Gold });

            List<Customer> customers = new List<Customer>();
            customers.Add(new Customer() { ID = 1, Name = "Homer Simpson", Type = 1 });
            customers.Add(new Customer() { ID = 2, Name = "Peter Griffin", Type = 1 });
            customers.Add(new Customer() { ID = 2, Name = "Hank Hill", Type = 2 });
            customers.Add(new Customer() { ID = 3, Name = "Phillip Fry", Type = 2 });

            
            dgGrid.DataSource = customers;

            ComboBoxItemsProvider pr = this.FindResource("provider") as ComboBoxItemsProvider;
            pr.DisplayMemberPath = "Type";
            pr.ItemsSource = customerTypes;
            
        }
    }



    public class Customer:INotifyPropertyChanged
    {
        private int _ID;
        private string _Name;
        private int _Type;

        public int ID
        {
            get { return _ID; }
            set 
            { 
                _ID = value;
                NotifyPropertyChanged("ID");
            }
        }

        public string Name
        {
            get { return _Name; }
            set 
            { 
                _Name = value;
                NotifyPropertyChanged("Name");
            }
        }

        public int Type
        {
            get { return _Type; }
            set 
            { 
                _Type = value;
                NotifyPropertyChanged("Type");
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

        #endregion
    }

    public class CustomerType:INotifyPropertyChanged
    {
        public enum CustomerTypes
        {
            Standard,
            Gold
        }

        private int _ID;
        private CustomerTypes _Name;

        public int ID
        {
            get { return _ID; }
            set 
            { 
                _ID = value;
                NotifyPropertyChanged("ID");
            }
        }
        
        public CustomerTypes Type
        {
            get { return _Name; }
            set 
            { 
                _Name = value;
                NotifyPropertyChanged("Type");
            }
        }
        public override string ToString()
        {
            return Type.ToString();
        }
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

        #endregion
    }

}
